﻿Imports NeuroSky.ThinkGear
'Imports NeuroSky.ThinkGear.Algorithms

Public Class Form1


    Private WithEvents conn1 As New Connector()
    Private stateString As String
    Private flagConnected As Boolean = False

    Private rawVal As Double
    Private sigVal As Double
    Private attVal As Double
    Private medVal As Double
    Private focVal As Double
    Private deltaVal As Double
    Private thetaVal As Double
    Private alpha1Val As Double
    Private alpha2Val As Double
    Private beta1Val As Double
    Private beta2Val As Double
    Private gamma1Val As Double
    Private gamma2Val As Double

    Private rawValue As Double
    Private signalValue As Double
    Private attentionValue As Double
    Private meditationValue As Double
    Private focusValue As Double
    Private deltaValue As Double
    Private thetaValue As Double
    Private alpha1Value As Double
    Private alpha2Value As Double
    Private beta1Value As Double
    Private beta2Value As Double
    Private gamma1Value As Double
    Private gamma2Value As Double

    Private RawSlot As Int32
    Private SignalSlot As Int32
    Private AttentionSlot As Int32
    Private MeditationSlot As Int32
    Private FocusSlot As Int32
    Private DeltaSlot As Int32
    Private ThetaSlot As Int32
    Private Alpha1Slot As Int32
    Private Alpha2Slot As Int32
    Private Beta1Slot As Int32
    Private Beta2Slot As Int32
    Private Gamma1Slot As Int32
    Private Gamma2Slot As Int32

    ' =======================================================================================
    '   FORM EVENTS
    ' =======================================================================================
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Text = AppTitleAndVersion("")
        Load_INI()
        SetLocales()
        StartConnection()
        ToolStrip1.Renderer = New ToolStripButtonRenderer
        EventsAreEnabled = True
        Refresh()
        Opacity = 1
    End Sub
    Private Sub Form1_FormClosing(ByVal sender As Object, _
                                  ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        CloseAllAndExit()
    End Sub
    Private Sub Form_LocationChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LocationChanged
        If Not EventsAreEnabled Then Exit Sub
        LimitFormPosition(Me)
    End Sub


    ' ===================================================================================
    '   MenuStrip and ToolStrip Gradients
    ' ===================================================================================
    Private Sub MenuStrip1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles MenuStrip1.Paint
        Dim bounds As New Rectangle(0, 0, _
                                    MenuStrip1.Width, MenuStrip1.Height)
        Dim brush As New Drawing2D.LinearGradientBrush(bounds, _
                                                       Color.FromArgb(230, 230, 230), _
                                                       Color.FromArgb(200, 200, 200), _
                                                       Drawing2D.LinearGradientMode.Horizontal)
        e.Graphics.FillRectangle(brush, bounds)
    End Sub
    Private Sub ToolStrip1_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles ToolStrip1.Paint
        Dim bounds As New Rectangle(0, 0, _
                                    ToolStrip1.Width, ToolStrip1.Height)
        Dim brush As New Drawing2D.LinearGradientBrush(bounds, _
                                                       Color.White, _
                                                       Color.FromArgb(200, 200, 200), _
                                                       Drawing2D.LinearGradientMode.Vertical)
        e.Graphics.FillRectangle(brush, bounds)
    End Sub


    ' ===================================================================================
    '   ToolStrip PressedButton color
    ' ===================================================================================
    Class ToolStripButtonRenderer
        Inherits System.Windows.Forms.ToolStripProfessionalRenderer
        Protected Overrides Sub OnRenderButtonBackground(ByVal e As ToolStripItemRenderEventArgs)
            Dim btn As ToolStripButton = CType(e.Item, ToolStripButton)
            If btn IsNot Nothing AndAlso btn.CheckOnClick AndAlso btn.Checked Then
                Dim bounds As Rectangle = New Rectangle(0, 0, e.Item.Width - 1, e.Item.Height - 1)
                Dim brush As New Drawing2D.LinearGradientBrush(bounds, _
                                                               Color.Gold, _
                                                               Color.FromArgb(250, 250, 250), _
                                                               Drawing2D.LinearGradientMode.Vertical)
                e.Graphics.FillRectangle(brush, bounds)
                e.Graphics.DrawRectangle(Pens.Orange, bounds)
            Else
                MyBase.OnRenderButtonBackground(e)
            End If
        End Sub
    End Class

    ' ===================================================================================
    '  MenuStrip and ToolStrip accepting the first click
    '  If the form receives a WM_PARENTNOTIFY (528) message and is not focused 
    '  then the form is activated before to exec the message
    ' ===================================================================================
    Protected Overrides Sub WndProc(ByRef m As Message)
        If m.Msg = 528 AndAlso Not Me.Focused Then
            Me.Activate()
        End If
        MyBase.WndProc(m)
    End Sub


    ' ===================================================================================
    '   
    ' ===================================================================================
    Private Sub Button_StartConnection_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles Button_StartConnection.ClickButtonArea
        StartConnection()
    End Sub
    Private Sub Button_StopConnection_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles Button_StopConnection.ClickButtonArea
        StopConnection
    End Sub

    Private Sub SlotTextBoxes_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) _
                                                                            Handles TextBoxRawSlot.TextChanged, _
                                                                                    TextBoxSignalSlot.TextChanged, _
                                                                                    TextBoxAttentionSlot.TextChanged, _
                                                                                    TextBoxMeditationSlot.TextChanged, _
                                                                                    TextBoxFocusSlot.TextChanged, _
                                                                                    TextBoxDeltaSlot.TextChanged, _
                                                                                    TextBoxThetaSlot.TextChanged, _
                                                                                    TextBoxAlpha1Slot.TextChanged, _
                                                                                    TextBoxAlpha2Slot.TextChanged, _
                                                                                    TextBoxBeta1Slot.TextChanged, _
                                                                                    TextBoxBeta2Slot.TextChanged, _
                                                                                    TextBoxGamma1Slot.TextChanged, _
                                                                                    TextBoxGamma2Slot.TextChanged
        UpdateSlots()
    End Sub
    Private Sub UpdateSlots()
        RawSlot = TextBoxRawSlot.NumericValueInteger
        SignalSlot = TextBoxSignalSlot.NumericValueInteger
        AttentionSlot = TextBoxAttentionSlot.NumericValueInteger
        MeditationSlot = TextBoxMeditationSlot.NumericValueInteger
        FocusSlot = TextBoxFocusSlot.NumericValueInteger
        DeltaSlot = TextBoxDeltaSlot.NumericValueInteger
        ThetaSlot = TextBoxThetaSlot.NumericValueInteger
        Alpha1Slot = TextBoxAlpha1Slot.NumericValueInteger
        Alpha2Slot = TextBoxAlpha2Slot.NumericValueInteger
        Beta1Slot = TextBoxBeta1Slot.NumericValueInteger
        Beta2Slot = TextBoxBeta2Slot.NumericValueInteger
        Gamma1Slot = TextBoxGamma1Slot.NumericValueInteger
        Gamma2Slot = TextBoxGamma2Slot.NumericValueInteger
    End Sub


    ' =======================================================================================
    '   START AND STOP CONNECTION
    ' =======================================================================================
    Private Sub StartConnection()
        'conn1.Close()
        conn1.ConnectScan("COM12")
        Timer1.Interval = 100
        Timer1.Start()
        Timer2.Interval = 100
        Timer2.Start()
    End Sub
    Private Sub StopConnection()
        conn1.EKGstopDetection()
        conn1.StopScan()
        conn1.Close()
    End Sub
    Private Sub CloseAllAndExit()
        Save_INI()
        StopConnection()
        End ' The NeuroskyDLL takes some seconds to close so this End facilitates debugging
    End Sub


    ' =======================================================================================
    '   MINDWAVE EVENTS
    ' =======================================================================================
    Private Sub conn1_DeviceConnected(ByVal sender As Object, ByVal e As System.EventArgs) Handles conn1.DeviceConnected
        Dim deviceEventArgs As Connector.DeviceEventArgs = CType(e, Connector.DeviceEventArgs)
        stateString = ("New Headset Created.")
        AddHandler deviceEventArgs.Device.DataReceived, AddressOf OnDataReceived
        stateString = ("BCI device connected on " + deviceEventArgs.Device.PortName.ToString)
        flagConnected = True
    End Sub
    Private Sub conn1_DeviceConnectFail(ByVal sender As Object, ByVal e As System.EventArgs) Handles conn1.DeviceConnectFail
        stateString = ("BCI device connection failed.")
        flagConnected = False
    End Sub
    Private Sub conn1_DeviceDisconnected(ByVal sender As Object, ByVal e As System.EventArgs) Handles conn1.DeviceDisconnected
        stateString = ("BCI device disconnected.")
        flagConnected = False
    End Sub
    Private Sub conn1_DeviceNotFound(ByVal sender As Object, ByVal e As System.EventArgs) Handles conn1.DeviceNotFound
        stateString = ("BCI device not found.")
        flagConnected = False
    End Sub
    Private Sub conn1_DeviceFound(ByVal sender As Object, ByVal e As System.EventArgs) Handles conn1.DeviceFound
        stateString = ("BCI device found.")
    End Sub
    Private Sub conn1_DeviceValidating(ByVal sender As Object, ByVal e As System.EventArgs) Handles conn1.DeviceValidating
        stateString = ("Searching BCI device.")
    End Sub
    Private Sub conn1_EKGPersonalizationEvent(ByVal sender As Object, ByVal e As System.EventArgs) Handles conn1.EKGPersonalizationEvent
        ' ???
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        If Not EventsAreEnabled Then Return
        UpdateUserInterface()
    End Sub

    Private Sub Timer2_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer2.Tick
        If Not EventsAreEnabled Then Return
        If flagConnected Then
            If Button_StartConnection.Enabled Then
                'Timer1.Stop()
                ResetSlots()
                ResetUserInterface()
            End If
            Button_StartConnection.Enabled = False
            Button_StopConnection.Enabled = True
        Else
            If Not Button_StartConnection.Enabled Then
                Button_StartConnection.Enabled = True
                Button_StopConnection.Enabled = False
            End If
        End If
        TextBoxState.Text = stateString
    End Sub

    ' =======================================================================================
    '   MENU FILE
    ' =======================================================================================
    Private Sub Menu_File_LoadConfiguration_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_File_LoadConfiguration.Click
        LoadConfiguration()
    End Sub
    Private Sub Menu_File_SaveConfigurationAs_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_File_SaveConfigurationAs.Click
        SaveConfigurationAs()
    End Sub
    Private Sub Menu_File_SaveImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_File_SaveImage.Click
        SaveImage("ThereminoMindwaveBridge_", Me)
    End Sub
    Private Sub Menu_File_Exit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_File_Exit.Click
        CloseAllAndExit()
    End Sub

    ' =======================================================================================
    '   MENU LANGUAGE
    ' =======================================================================================
    Private Sub Menu_Language_DropDownOpening(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu_Language.DropDownOpening
        For Each item As ToolStripMenuItem In Menu_Language.DropDownItems
            If item.Name.EndsWith(Language, StringComparison.InvariantCultureIgnoreCase) Then
                item.Select()
            End If
        Next
    End Sub
    Private Sub Menu_Language_Deutsch_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu_Language_Deutsch.Click
        Language = "Deutsch"
        SetLocales()
        Save_INI()
    End Sub
    Private Sub Menu_Language_English_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu_Language_English.Click
        Language = "English"
        SetLocales()
        Save_INI()
    End Sub
    Private Sub Menu_Language_Espanol_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu_Language_Espanol.Click
        Language = "Espanol"
        SetLocales()
        Save_INI()
    End Sub
    Private Sub Menu_Language_Francais_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu_Language_Francais.Click
        Language = "Francais"
        SetLocales()
        Save_INI()
    End Sub
    Private Sub Menu_Language_Italian_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu_Language_Italian.Click
        Language = "Italian"
        SetLocales()
        Save_INI()
    End Sub
    Private Sub Menu_Language_Japanese_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Language_Japanese.Click
        Language = "Japanese"
        SetLocales()
        Save_INI()
    End Sub

    ' =======================================================================================
    '   MENU HELP
    ' =======================================================================================
    Private Sub Menu_Help_ProgramHelp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Help_ProgramHelp.Click
        OpenLocalizedHelp("ThereminoMindwaveBridge_Help", ".pdf")
    End Sub
    Private Sub Menu_Help_OpenProgramFolder_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Help_OpenProgramFolder.Click
        Process.Start(Application.StartupPath)
    End Sub
    Private Sub OpenLocalizedHelp(ByVal name As String, Optional ByVal ext As String = ".rtf")

        Dim fname As String = PlatformAdjustedFileName(Application.StartupPath & "\Docs\" & name & "_" & Strings.Left(Language, 3).ToUpper & ext)
        If FileExists(fname) Then
            Process.Start(fname)
        Else
            fname = PlatformAdjustedFileName(Application.StartupPath & "\Docs\" & name & "_ENG" & ext)
            If FileExists(fname) Then
                Process.Start(fname)
            Else
                fname = PlatformAdjustedFileName(Application.StartupPath & "\Docs\" & name & "_ITA" & ext)
                If FileExists(fname) Then
                    Process.Start(fname)
                Else
                    fname = PlatformAdjustedFileName(Application.StartupPath & "\Docs\" & name & ext)
                    If FileExists(fname) Then
                        Process.Start(fname)
                    End If
                End If
            End If
        End If
    End Sub

    ' =======================================================================================
    '   MENU ABOUT
    ' =======================================================================================
    Private Sub Menu_About_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_About.Click
        Form_About.ShowDialog()
    End Sub

    ' =======================================================================================
    '   TOOLBAR
    ' =======================================================================================
    Private Sub ToolStripButton_SaveImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton_SaveImage.Click
        ToolStripButton_SaveImage.Visible = False
        ToolStripButton_SaveImage.Visible = True
        Me.Refresh()
        SaveImage("ThereminoMindwaveBridge_", Me)
    End Sub


    ' =======================================================================================
    '   MIXED FUNCTIONS
    ' =======================================================================================
    Private Sub ResetSlots()
        For i As Int32 = 0 To 999
            Slots.WriteSlot(i, 0)
        Next
    End Sub
    Private Sub ResetUserInterface()
        TextBoxState.Text = ""

        TextBoxraw.Text = ""
        TextBoxRawOut.Text = ""
        ProgressBarRaw.Value = 0

        TextBoxSignal.Text = ""
        TextBoxSignalOut.Text = ""
        ProgressBarSignal.Value = 0

        TextBoxAttention.Text = ""
        TextBoxAttentionOut.Text = ""
        ProgressBarAttention.Value = 0

        TextBoxMeditation.Text = ""
        TextBoxMeditationOut.Text = ""
        ProgressBarMeditation.Value = 0

        TextBoxFocus.Text = ""
        TextBoxFocusOut.Text = ""
        ProgressBarFocus.Value = 0

        TextBoxDelta.Text = ""
        TextBoxDeltaOut.Text = ""
        ProgressBarDelta.Value = 0

        TextBoxTheta.Text = ""
        TextBoxThetaOut.Text = ""
        ProgressBarTheta.Value = 0

        TextBoxAlpha1.Text = ""
        TextBoxAlpha1Out.Text = ""
        ProgressBarAlpha1.Value = 0

        TextBoxAlpha2.Text = ""
        TextBoxAlpha2Out.Text = ""
        ProgressBarAlpha2.Value = 0

        TextBoxBeta1.Text = ""
        TextBoxBeta1Out.Text = ""
        ProgressBarBeta1.Value = 0

        TextBoxBeta2.Text = ""
        TextBoxBeta2Out.Text = ""
        ProgressBarBeta2.Value = 0

        TextBoxGamma1.Text = ""
        TextBoxGamma1Out.Text = ""
        ProgressBarGamma1.Value = 0

        TextBoxGamma2.Text = ""
        TextBoxGamma2Out.Text = ""
        ProgressBarGamma2.Value = 0
    End Sub

    ' =======================================================================================
    '   MINDWAVE FUNCTIONS
    ' =======================================================================================
    Private Sub UpdateUserInterface()

        TextBoxraw.Text = rawVal.ToString
        TextBoxRawOut.Text = rawValue.ToString
        ProgressBarRaw.Value = CInt(rawValue)

        TextBoxSignal.Text = sigVal.ToString
        TextBoxSignalOut.Text = signalValue.ToString
        ProgressBarSignal.Value = CInt(signalValue)

        TextBoxAttention.Text = attVal.ToString
        TextBoxAttentionOut.Text = attentionValue.ToString
        ProgressBarAttention.Value = CInt(attentionValue)

        TextBoxMeditation.Text = medVal.ToString
        TextBoxMeditationOut.Text = meditationValue.ToString
        ProgressBarMeditation.Value = CInt(meditationValue)

        TextBoxFocus.Text = focVal.ToString
        TextBoxFocusOut.Text = focusValue.ToString
        ProgressBarFocus.Value = CInt(focusValue)

        TextBoxDelta.Text = deltaVal.ToString
        TextBoxDeltaOut.Text = deltaValue.ToString
        ProgressBarDelta.Value = CInt(deltaValue)

        TextBoxTheta.Text = thetaVal.ToString
        TextBoxThetaOut.Text = thetaValue.ToString
        ProgressBarTheta.Value = CInt(thetaValue)

        TextBoxAlpha1.Text = alpha1Val.ToString
        TextBoxAlpha1Out.Text = alpha1Value.ToString
        ProgressBarAlpha1.Value = CInt(alpha1Value)

        TextBoxAlpha2.Text = alpha2Val.ToString
        TextBoxAlpha2Out.Text = alpha2Value.ToString
        ProgressBarAlpha2.Value = CInt(alpha2Value)

        TextBoxBeta1.Text = beta1Val.ToString
        TextBoxBeta1Out.Text = beta1Value.ToString
        ProgressBarBeta1.Value = CInt(beta1Value)

        TextBoxBeta2.Text = beta2Val.ToString
        TextBoxBeta2Out.Text = beta2Value.ToString
        ProgressBarBeta2.Value = CInt(beta2Value)

        TextBoxGamma1.Text = gamma1Val.ToString
        TextBoxGamma1Out.Text = gamma1Value.ToString
        ProgressBarGamma1.Value = CInt(gamma1Value)

        TextBoxGamma2.Text = gamma2Val.ToString
        TextBoxGamma2Out.Text = gamma2Value.ToString
        ProgressBarGamma2.Value = CInt(gamma2Value)
    End Sub

    Private Sub OnDataReceived(ByVal sender As Object, ByVal e As EventArgs)
        Dim d As Device = CType(sender, Device)
        Dim de As Device.DataEventArgs = CType(e, Device.DataEventArgs)
        Dim tgParser As New TGParser()
        Dim i As Integer
        Dim n As Double

        tgParser.Read(de.DataRowArray)

        For i = 0 To tgParser.ParsedData.Length - 1

            If tgParser.ParsedData(i).ContainsKey("Raw") Then
                rawVal = tgParser.ParsedData(i)("Raw")
                n = TextBoxRawOffset.NumericValue + rawVal * TextBoxRawGain.NumericValue
                If n > 1000 Then n = 1000
                If n < 0 Then n = 0
                rawValue = n
                Slots.WriteSlot(RawSlot, rawValue)
            End If

            If tgParser.ParsedData(i).ContainsKey("PoorSignal") Then
                sigVal = tgParser.ParsedData(i)("PoorSignal")
                n = TextBoxSignalOffset.NumericValue + sigVal * TextBoxSignalGain.NumericValue
                If n > 1000 Then n = 1000
                If n < 0 Then n = 0
                signalValue = n
                Slots.WriteSlot(SignalSlot, signalValue)
            End If

            If tgParser.ParsedData(i).ContainsKey("Attention") Then
                attVal = tgParser.ParsedData(i)("Attention")
                n = TextBoxAttentionOffset.NumericValue + attVal * TextBoxAttentionGain.NumericValue
                If n > 1000 Then n = 1000
                If n < 0 Then n = 0
                attentionValue = n
                Slots.WriteSlot(AttentionSlot, attentionValue)
            End If

            If tgParser.ParsedData(i).ContainsKey("Meditation") Then
                medVal = tgParser.ParsedData(i)("Meditation")
                n = TextBoxMeditationOffset.NumericValue + medVal * TextBoxMeditationGain.NumericValue
                If n > 1000 Then n = 1000
                If n < 0 Then n = 0
                meditationValue = n
                Slots.WriteSlot(MeditationSlot, meditationValue)
            End If

            focVal = (attVal + medVal) / 2
            n = TextBoxFocusOffset.NumericValue + _
                         ((attentionValue / TextBoxAttentionGain.NumericValue) _
                         + (meditationValue / TextBoxMeditationGain.NumericValue)) _
                         * (TextBoxFocusGain.NumericValue / 2)
            If n > 1000 Then n = 1000
            If n < 0 Then n = 0
            focusValue = n
            Slots.WriteSlot(FocusSlot, focusValue)

            If tgParser.ParsedData(i).ContainsKey("EegPowerDelta") Then
                deltaVal = tgParser.ParsedData(i)("EegPowerDelta")
                n = TextBoxDeltaOffset.NumericValue + deltaVal * TextBoxDeltaGain.NumericValue
                If n > 1000 Then n = 1000
                If n < 0 Then n = 0
                deltaValue = CInt(n)
                Slots.WriteSlot(DeltaSlot, deltaValue)
            End If

            If tgParser.ParsedData(i).ContainsKey("EegPowerTheta") Then
                thetaVal = tgParser.ParsedData(i)("EegPowerTheta")
                n = TextBoxThetaOffset.NumericValue + thetaVal * TextBoxThetaGain.NumericValue
                If n > 1000 Then n = 1000
                If n < 0 Then n = 0
                thetaValue = CInt(n)
                Slots.WriteSlot(ThetaSlot, thetaValue)
            End If

            If tgParser.ParsedData(i).ContainsKey("EegPowerAlpha1") Then
                alpha1Val = tgParser.ParsedData(i)("EegPowerAlpha1")
                n = TextBoxAlpha1Offset.NumericValue + alpha1Val * TextBoxAlpha1Gain.NumericValue
                If n > 1000 Then n = 1000
                If n < 0 Then n = 0
                alpha1Value = CInt(n)
                Slots.WriteSlot(Alpha1Slot, alpha1Value)
            End If

            If tgParser.ParsedData(i).ContainsKey("EegPowerAlpha2") Then
                alpha2Val = tgParser.ParsedData(i)("EegPowerAlpha2")
                n = TextBoxAlpha2Offset.NumericValue + alpha2Val * TextBoxAlpha2Gain.NumericValue
                If n > 1000 Then n = 1000
                If n < 0 Then n = 0
                alpha2Value = CInt(n)
                Slots.WriteSlot(Alpha2Slot, alpha2Value)
            End If

            If tgParser.ParsedData(i).ContainsKey("EegPowerBeta1") Then
                beta1Val = tgParser.ParsedData(i)("EegPowerBeta1")
                n = TextBoxBeta1Offset.NumericValue + beta1Val * TextBoxBeta1Gain.NumericValue
                If n > 1000 Then n = 1000
                If n < 0 Then n = 0
                beta1Value = CInt(n)
                Slots.WriteSlot(TextBoxBeta1Slot.NumericValueInteger, beta1Value)
            End If

            If tgParser.ParsedData(i).ContainsKey("EegPowerBeta2") Then
                beta2Val = tgParser.ParsedData(i)("EegPowerBeta2")
                n = TextBoxBeta2Offset.NumericValue + beta2Val * TextBoxBeta2Gain.NumericValue
                If n > 1000 Then n = 1000
                If n < 0 Then n = 0
                beta2Value = CInt(n)
                Slots.WriteSlot(TextBoxBeta2Slot.NumericValueInteger, beta2Value)
            End If

            If tgParser.ParsedData(i).ContainsKey("EegPowerGamma1") Then
                gamma1Val = tgParser.ParsedData(i)("EegPowerGamma1")
                n = TextBoxGamma1Offset.NumericValue + gamma1Val * TextBoxGamma1Gain.NumericValue
                If n > 1000 Then n = 1000
                If n < 0 Then n = 0
                gamma1Value = CInt(n)
                Slots.WriteSlot(Gamma1Slot, gamma1Value)
            End If

            If tgParser.ParsedData(i).ContainsKey("EegPowerGamma2") Then
                gamma2Val = tgParser.ParsedData(i)("EegPowerGamma2")
                n = TextBoxGamma2Offset.NumericValue + gamma2Val * TextBoxGamma2Gain.NumericValue
                If n > 1000 Then n = 1000
                If n < 0 Then n = 0
                gamma2Value = CInt(n)
                Slots.WriteSlot(Gamma2Slot, gamma2Value)
            End If
        Next
    End Sub

End Class
